// mpicc Ex3.c -Wall -o Ex3.x

#include <stdio.h>
#include <stdlib.h>
#include "mpi.h"

int myMPI_Bcast( void *buffer, int count, MPI_Datatype datatype,
                 int root, MPI_Comm comm )
{
    int myrank, nprocs;
    int tag = 0;

    MPI_Comm_rank( comm, &myrank );
    MPI_Comm_size( comm, &nprocs );

    if ( myrank == root )
    {
        int i;
        for ( i = 0; i < nprocs; i++ )
        {
            if ( i == myrank )
                continue;
            MPI_Send( buffer, count, datatype, i, tag, comm );
        }
    }
    else
    {
        MPI_Recv( buffer, count, datatype, root, tag, comm, MPI_STATUS_IGNORE );
    }

    return 0;
}

int main( int argc, char *argv[] )
{   
    int i;
    int ROOT = 0;
    int myrank;
    int buffer[3];

    MPI_Init(&argc,&argv);

    MPI_Comm_rank( MPI_COMM_WORLD, &myrank );

    if ( myrank == ROOT )
    {
        buffer[ 0 ] = rand() % 20;
        buffer[ 1 ] = rand() % 20;
        buffer[ 2 ] = rand() % 20;
    }
    
    myMPI_Bcast( (void *)buffer, 3, MPI_INT, ROOT, MPI_COMM_WORLD );

    for ( i = 0; i < 3; i++ )
        printf( "[%d] %d: %d\n", myrank, i, buffer[i] );

    MPI_Finalize();
    return 0;
}


